#include "sudoku.hpp"
#include <fstream>
#include <iostream>
#include <string>


Sudoku::Sudoku(void) {
    board.resize(9, std::vector<int>(9, -1));
}

void Sudoku::FillBoard(std::string filePath) {
    std::ifstream sudokuFile(filePath);
    if (!sudokuFile) {
        std::cerr << "Error opening file: " << filePath << std::endl;
        exit(1);
    }
    std::string line;
    while (!sudokuFile.eof()) { 
        sudokuFile >> line;
        std::cout << line << std::endl; 
    }
    // TODO: Finish inputting sudoku file 
    //       Really just needs to be split by digit then stored

}

// TODO: Implement solving algorithm
void Sudoku::Solve(void) {

}

// TODO: Add checking for full board completion
bool Sudoku::IsBoardSolved(void) {
    return true;
}

// TODO: Add printing of board for visuals
//       Maybe also print during solve?
void Sudoku::Print(void) {

}

// TODO: Add checking for row completion
bool Sudoku::IsRowComplete(int row) {
    return true;
}

// TODO: Add checking for column completion
bool Sudoku::IsColumnComplete(int column) {
    return true;
}

// WARNING: This function and one below could be swapped, untested
std::vector<int> Sudoku::GetUnusedInRow(int row) {
    std::vector<int> leftOver{0,1,2,3,4,5,6,7,8,9};
    int number;
    for (int i = 0; i < 9; i++) {
        number = board[i][row];
        if (leftOver[number] == number) {
            leftOver[number] = 0;
        }
        if (leftOver[number] == 0) { // Two of same number was placed
            leftOver[number] = -1;
        }
    }
    for (auto it = leftOver.begin(); it != leftOver.end();) {
        if (*it == 0) { it = leftOver.erase(it); }
        else { ++it; }
    }
    return leftOver;
}

std::vector<int> Sudoku::GetUnusedInColumn(int column) {
    std::vector<int> leftOver{0,1,2,3,4,5,6,7,8,9};
    int number;
    for (int i = 0; i < 9; i++) {
        number = board[column][i];
        if (leftOver[number] == number) {
            leftOver[number] = 0;
        }
        if (leftOver[number] == 0) { // Two of same number was placed
            leftOver[number] = -1;
        }
    }
    for (auto it = leftOver.begin(); it != leftOver.end();) {
        if (*it == 0) { it = leftOver.erase(it); }
        else { ++it; }
    }
    return leftOver;
}
